﻿Public Class UserController
    Inherits System.Web.Mvc.Controller

    Function UserManager(ByVal page As Integer?) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        Dim viewmodel As New ViewModelUser
        Dim service As New UserService
        If Not page Is Nothing Then
            Try
                viewmodel = service.GetList(viewmodel, page - 1)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
        End If
        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function UserManager(ByVal viewmodel As ViewModelUser, ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        If collection("button") = "検索" Then
            Dim service As New UserService

            Try
                viewmodel = service.GetList(viewmodel, 0)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try

            Return View(viewmodel)
        Else
            Session("Screen") = "NewUser"
            Return RedirectToAction("NewUser", "User")
        End If
    End Function

    Function NewUser() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "NewUser" Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim viewmodel As ViewModelNewUser = TryCast(Session("NewUserData"), ViewModelNewUser)

        If viewmodel Is Nothing Then
            viewmodel = New ViewModelNewUser
        End If
        Dim service As New UserService


        Try
            viewmodel = service.GetNewUserData(viewmodel)
        Catch ex As Exception
            Return RedirectToAction("Maintenance", "Home")
        End Try


        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function NewUser(ByVal viewmodel As ViewModelNewUser, ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "NewUser" Then
            Return RedirectToAction("Maintenance", "Home")
        End If


        If collection("button") = "戻る" Then ' 戻るボタンを押したとき
            Session("Screen") = Nothing
            Return RedirectToAction("UserManager", "User")
        Else
            Dim service As New UserService
            Try
                viewmodel = service.GetNewUserData(viewmodel)
                viewmodel.ROLE_NAME = Util.GetRoleString(viewmodel.ROLE, viewmodel.ROLE_CHECKBOXLIST)
                viewmodel.MASKED_PASSWORD = Util.Mask(viewmodel.PASSWORD)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try

            Session("NewUserData") = viewmodel

            If ModelState.IsValid = True Then
                Session("Screen") = "NewUserConfirm"
                Return RedirectToAction("NewUserConfirm", "User")
            Else
                Return View(viewmodel)
            End If
        End If
    End Function

    Function NewUserConfirm() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "NewUserConfirm" Then
            Return RedirectToAction("Maintenance", "Home")
        End If


        Dim viewmodel As ViewModelNewUser = TryCast(Session("NewUserData"), ViewModelNewUser)

        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function NewUserConfirm(ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "NewUserConfirm" Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If collection("button") = "戻る" Then
            Session("Screen") = "NewUser"
            Return RedirectToAction("NewUser", "User")
        Else
            Dim viewmodel As ViewModelNewUser = TryCast(Session("NewUserData"), ViewModelNewUser)

            Dim service As New UserService

            Try
                service.SaveNewUser(viewmodel)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try


            ' メッセージボックスの表示
            Session("MessageBoxTitle") = "ユーザ登録完了"
            Session("MessageBoxMessage") = "ユーザ登録が完了しました"

            Session("NewUserData") = Nothing
            Session("Screen") = Nothing

            Return RedirectToAction("MessageBox", "Home")

        End If

    End Function

    Function EditUser(ByVal id As String) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        Dim viewmodel As ViewModelEditUser = TryCast(Session("EditUserData"), ViewModelEditUser)
        Dim service As New UserService

        Try
            If viewmodel Is Nothing Then
                viewmodel = New ViewModelEditUser
                viewmodel.OPERATOR_ID = id
                viewmodel = service.GetEditUserData(viewmodel)
            Else
                viewmodel = service.GetEditUserDataForConfirm(viewmodel)
            End If
        Catch ex As Exception
            Return RedirectToAction("Maintenance", "Home")
        End Try



        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function EditUser(ByVal id As String, ByVal viewmodel As ViewModelEditUser, ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        If collection("button") = "戻る" Then ' 戻るボタンを押したとき
            Session("EditUserData") = Nothing
            Session("Screen") = Nothing
            Return RedirectToAction("UserManager", "User")
        Else
            Dim service As New UserService
            Try
                viewmodel.OPERATOR_ID = id
                viewmodel = service.GetEditUserDataForConfirm(viewmodel)
                viewmodel.ROLE_NAME = Util.GetRoleString(viewmodel.ROLE, viewmodel.ROLE_CHECKBOXLIST)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
            Session("EditUserData") = viewmodel

            If ModelState.IsValid = True Then
                Session("Screen") = "EditUserConfirm"
                Return RedirectToAction("EditUserConfirm", "User")
            Else
                Return View(viewmodel)
            End If
        End If
    End Function

    Function EditUserConfirm() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "EditUserConfirm" Then
            Return RedirectToAction("Maintenance", "Home")
        End If


        Dim viewmodel As ViewModelEditUser = TryCast(Session("EditUserData"), ViewModelEditUser)

        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function EditUserConfirm(ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "EditUserConfirm" Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim viewmodel As ViewModelEditUser = TryCast(Session("EditUserData"), ViewModelEditUser)

        If collection("button") = "戻る" Then ' 戻るボタンを押したとき
            Session("Screen") = "EditUser"
            Return RedirectToAction("EditUser/" & viewmodel.OPERATOR_ID, "User")
        Else ' 保存ボタンを押したとき
            Dim service As New UserService
            Try
                service.SaveEditUser(viewmodel)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
            ' メッセージボックスの表示
            Session("MessageBoxTitle") = "ユーザ更新完了"
            Session("MessageBoxMessage") = "ユーザ更新が完了しました"

            Session("EditUserData") = Nothing
            Session("Screen") = Nothing

            Return RedirectToAction("MessageBox", "Home")
        End If
    End Function


    Function EditPassword(ByVal id As String) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        Dim viewmodel As ViewModelEditPassword = TryCast(Session("EditPasswordData"), ViewModelEditPassword)

        If viewmodel Is Nothing Then
            viewmodel = New ViewModelEditPassword
        End If

        viewmodel.OPERATOR_ID = id

        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function EditPassword(ByVal id As String, ByVal viewmodel As ViewModelEditPassword, ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        If collection("button") = "戻る" Then ' 戻るボタンを押したとき
            Session("EditPasswordData") = Nothing
            Session("Screen") = Nothing
            Return RedirectToAction("UserManager", "User")
        Else
            Dim service As New UserService
            viewmodel.OPERATOR_ID = id
            viewmodel.MASKED_PASSWORD = Util.Mask(viewmodel.PASSWORD)

            Session("EditPasswordData") = viewmodel
            If ModelState.IsValid = True Then
                Session("Screen") = "EditPasswordConfirm"
                Return RedirectToAction("EditPasswordConfirm", "User")
            Else
                Return View(viewmodel)

            End If
        End If
    End Function

    Function EditPasswordConfirm() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "EditPasswordConfirm" Then
            Return RedirectToAction("Maintenance", "Home")
        End If


        Dim viewmodel As ViewModelEditPassword = TryCast(Session("EditPasswordData"), ViewModelEditPassword)

        Return View(viewmodel)
    End Function

    <HttpPost()>
    Function EditPasswordConfirm(ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        If acc Is Nothing OrElse Not acc.ROLE("User Manager") Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If Session("Screen") <> "EditPasswordConfirm" Then
            Return RedirectToAction("Maintenance", "Home")
        End If


        Dim viewmodel As ViewModelEditPassword = TryCast(Session("EditPasswordData"), ViewModelEditPassword)

        If collection("button") = "戻る" Then ' 戻るボタンを押したとき
            Session("Screen") = "EditPassword"
            Return RedirectToAction("EditPassword/" & viewmodel.OPERATOR_ID, "User")
        Else ' 保存ボタンを押したとき
            Dim service As New UserService
            Try
                service.SaveEditPassword(viewmodel)
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
            ' メッセージボックスの表示
            Session("MessageBoxTitle") = "パスワード変更完了"
            Session("MessageBoxMessage") = "パスワード変更が完了しました"

            Session("PasswordChangeData") = Nothing
            Session("Screen") = Nothing

            Return RedirectToAction("MessageBox", "Home")
        End If
    End Function

End Class