﻿jQuery.validator.addMethod("ismail", function (value, element, param) {
    var re = new RegExp("^[a-zA-Z_0-9]+([-+.][a-zA-Z_0-9]+)*@[a-zA-Z_0-9]+([-.][a-zA-Z_0-9]+)*\.[a-zA-Z_0-9]+([-.][a-zA-Z_0-9]+)*$");

    var result = re.exec(value);

    return result;
});

jQuery.validator.addMethod("includehalfcharacter", function (value, element, param) {
    var re = new RegExp("[ -~｡-ﾟ]+");

    var result = re.exec(value);

    return !result;
});

jQuery.validator.addMethod("isnumeric", function (value, element, param) {
    var re = new RegExp("^[0-9]*$");

    var result = re.exec(value);

    return result;
});

jQuery.validator.addMethod("isalphanumeric", function (value, element, param) {
    var re = new RegExp("^[0-9a-zA-Z]*$");

    var result = re.exec(value);

    return result;
});

jQuery.validator.addMethod("validatepassword", function (value, element, param) {
    var pat1 = new RegExp('^[a-zA-Z0-9!-\/:-@\[-`{-~]{6,20}$');
    var pat2 = new RegExp("[0-9]");
    var pat3 = new RegExp("[a-z]");
    var pat4 = new RegExp("[A-Z]");

    if (pat1.exec(value)) {
        if (pat2.exec(value) && pat3.exec(value) && pat4.exec(value)) {
            return true;
        }
    }
    return false;
});

jQuery.validator.addMethod("iskatakana", function (value, element, param) {
    var re = new RegExp("^[ァ-ヶ|ー]+$");

    var result = re.exec(value);

    return result;
});

jQuery.validator.addMethod("includespecialcharacter", function (value, element, param) {
    var re = new RegExp("[①②③④⑤⑥⑦⑧⑨⑩⑪⑫⑬⑭⑮⑯⑰⑱⑲⑳ⅠⅡⅢⅣⅤ≡∑∫∮√⊥∠∟⊿∵∩∪№㏍℡㊤㊥㊦㊧㊨㈱㈲㈹㍾㍽㍼㍻㍉㎜㎝㎞㎎㎏㏄㍉㌔㌢㍍㌘㌧㌃㌶㍑㍗㌍㌦㌣㌫㍊㌻ⅠⅡⅢⅣⅤⅥⅦⅧⅨⅩ]+");

    var result = re.exec(value);

    return !result;
});

jQuery.validator.addMethod("includezenkakualphabet", function (value, element, param) {
    var re = new RegExp("[ａ-ｚＡ-Ｚ]+");

    var result = re.exec(value);

    return !result;
});

jQuery.validator.addMethod("includezenkakunumeric", function (value, element, param) {
    var re = new RegExp("[０-９]+");

    var result = re.exec(value);

    return !result;
});

jQuery.validator.addMethod("isdate", function (value, element, param) {
    if (value == '') {
        return true;
    }

    // 正規表現による書式チェック
    if (!value.match(/^\d{4}\/\d{2}\/\d{2}$/)) {
        return false;
    }
    var vYear = value.substr(0, 4) - 0;
    var vMonth = value.substr(5, 2) - 1; // Javascriptは、0-11で表現
    var vDay = value.substr(8, 2) - 0;
    // 月,日の妥当性チェック
    if (vMonth >= 0 && vMonth <= 11 && vDay >= 1 && vDay <= 31) {
        var vDt = new Date(vYear, vMonth, vDay);
        if (isNaN(vDt)) {
            return false;
        } else if (vDt.getFullYear() == vYear && vDt.getMonth() == vMonth && vDt.getDate() == vDay) {
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }

});

jQuery.validator.addMethod("requiredoccupation", function (value, element, param) {
    if (value == "0") {
        return false;
    } else {
        return true;
    }
});

jQuery.validator.addMethod("samevalue", function (value, element, param) {
    var v1 = $('#' + param.opts1).val();
    var v2 = $('#' + param.opts2).val();

    if (v1 == v2) {
        return true;
    } else {
        return false;
    }
});

jQuery.validator.addMethod("startend", function (value, element, param) {
    var v1 = $('#' + param.opts1).val();
    var v2 = $('#' + param.opts2).val();

    if (v1 >= v2) {
        return false;
    } else {
        return true;
    }
});

jQuery.validator.addMethod("telandmtelvalidator", function (value, element, param) {
    var tel1 = $('#' + param.opts1).val();
    var tel2 = $('#' + param.opts2).val();
    var tel3 = $('#' + param.opts3).val();
    var mtel1 = $('#' + param.opts4).val();
    var mtel2 = $('#' + param.opts5).val();
    var mtel3 = $('#' + param.opts6).val();

    if (tel1 == '' && tel2 == '' && tel3 == '' && mtel1 == '' && mtel2 == '' && mtel3 == '') {
        return false;
    } else {
        return true;
    }
});

jQuery.validator.addMethod("telvalidator", function (value, element, param) {
    var tel1 = $('#' + param.opts1).val();
    var tel2 = $('#' + param.opts2).val();
    var tel3 = $('#' + param.opts3).val();

    if (tel1 != '' || tel2 != '' || tel3 != '') {
        if (tel1 == '' && element.id == 'TEL1') {
            return false;
        }

        if (tel2 == '' && element.id == 'TEL2') {
            return false;
        }

        if (tel3 == '' && element.id == 'TEL3') {
            return false;
        }
    }

    return true;
});

jQuery.validator.addMethod("mtelvalidator", function (value, element, param) {
    var mtel1 = $('#' + param.opts1).val();
    var mtel2 = $('#' + param.opts2).val();
    var mtel3 = $('#' + param.opts3).val();

    if (mtel1 != '' || mtel2 != '' || mtel3 != '') {
        if (mtel1 == '' && element.id == 'M_TEL1') {
            return false;
        }

        if (mtel2 == '' && element.id == 'M_TEL2') {
            return false;
        }

        if (mtel3 == '' && element.id == 'M_TEL3') {
            return false;
        }
    }

    return true;
});




jQuery.validator.unobtrusive.adapters.addSingleVal('ismail', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('includehalfcharacter', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('isnumeric', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('isalphanumeric', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('validatepassword', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('iskatakana', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('includespecialcharacter', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('includezenkakualphabet', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('includezenkakunumeric', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('isdate', 'opts');
jQuery.validator.unobtrusive.adapters.addSingleVal('requiredoccupation', 'opts');
jQuery.validator.unobtrusive.adapters.add('samevalue', new Array('opts1', 'opts2'), function (options) {
    options.rules['samevalue'] = options.params;
    options.messages['samevalue'] = options.message;
});
jQuery.validator.unobtrusive.adapters.add('startend', new Array('opts1', 'opts2'), function (options) {
    options.rules['startend'] = options.params;
    options.messages['startend'] = options.message;
});


jQuery.validator.unobtrusive.adapters.add('telandmtelvalidator', new Array('opts1', 'opts2', 'opts3', 'opts4', 'opts5', 'opts6'), function (options) {
    options.rules['telandmtelvalidator'] = options.params;
    options.messages['telandmtelvalidator'] = options.message;
});

jQuery.validator.unobtrusive.adapters.add('telvalidator', new Array('opts1', 'opts2', 'opts3'), function (options) {
    options.rules['telvalidator'] = options.params;
    if (options.element.id == 'TEL1') {
        options.messages['telvalidator'] = '自宅電話番号（市外局番）を入力してください。';
    } else if (options.element.id == 'TEL2') {
        options.messages['telvalidator'] = '自宅電話番号（局番）を入力してください。';
    } else if (options.element.id == 'TEL3') {
        options.messages['telvalidator'] = '自宅電話番号（枝番）を入力してください。';
    }
});

jQuery.validator.unobtrusive.adapters.add('mtelvalidator', new Array('opts1', 'opts2', 'opts3'), function (options) {
    options.rules['mtelvalidator'] = options.params;
    if (options.element.id == 'M_TEL1') {
        options.messages['mtelvalidator'] = '携帯電話番号（先頭３桁）を入力してください。';
    } else if (options.element.id == 'M_TEL2') {
        options.messages['mtelvalidator'] = '携帯電話番号（中央４桁）を入力してください。';
    } else if (options.element.id == 'M_TEL3') {
        options.messages['mtelvalidator'] = '携帯電話番号（末尾４桁）を入力してください。';
    }
});


