﻿$(function () {
    $('#SEI_KANA').change(function () {
        convHiraganaToKatakana($(this));
    });

    $('#MEI_KANA').change(function () {
        convHiraganaToKatakana($(this));
    });

    $('#Cancel').click(function () {
        var validator = $(this).closest('form').validate();
        validator.cancelSubmit = true;
    });

    $('#PasswordChange').click(function () {
        var validator = $(this).closest('form').validate();
        validator.cancelSubmit = true;
    });

    //日付選択カレンダー
    var cur = new Date();
    var gyear = cur.getFullYear();
    var yrange = '1900' + ':' + gyear;
    var opt = {
        regional: 'ja',
        dateFormat: 'yy/mm/dd',
        prevText: '&#x3c;前',
        nextText: '次&#x3e;',
        currentText: '今日',
        monthNames: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
        monthNamesShort: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
        dayNames: ['日曜日', '月曜日', '火曜日', '水曜日', '木曜日', '金曜日', '土曜日'],
        dayNamesShort: ['日', '月', '火', '水', '木', '金', '土'],
        dayNamesMin: ['日', '月', '火', '水', '木', '金', '土'],
        weekHeader: '週',
        firstDay: 1,
        showMonthAfterYear: true,
        yearSuffix: '年',
        showOn: 'button',
        buttonImage: '/Content/image/calendar.jpg',
        buttonImageOnly: true,
        buttonText: 'カレンダーから選択',
        changeYear: true,
        yearRange: yrange,
        changeMonth: true,
        autoSize: true
    };
    $(".calendar").datepicker(opt);

});

function convHiraganaToKatakana(input) {
    var output = '';
    var c;
    var n;
    for (var i = 0; i < input.val().length; i++) {
        c = input.val().charAt(i);
        n = c.charCodeAt(0);
        if ((n >= 0x3041) && (n <= 0x3096)) {
            c = String.fromCharCode(n + 0x60);
        }
        output += c;
    }
    input.val(output);
}
