﻿Imports System.Transactions

Public Class LoginService
    Public Function IsMstUser(ByVal viewmodel As ViewModelLogin) As Boolean
        Dim db As New MeetingRoomDBDataContext

        Dim mstuser = (From r In db.GetTable(Of MST_USER)() Select r
                           Where r.OPERATOR_ID = viewmodel.OPERATOR_ID).FirstOrDefault

        If mstuser Is Nothing Then
            Return False
        Else
            Return True
        End If
    End Function


    Public Function GetMstUser(ByVal viewmodel As ViewModelLogin) As ViewModelLogin
        Dim db As New MeetingRoomDBDataContext

        Dim mstuser = (From r In db.GetTable(Of MST_USER)() Select r
                           Where r.OPERATOR_ID = viewmodel.OPERATOR_ID).First

        viewmodel.OPERATOR_NAME = mstuser.OPERATOR_NAME
        viewmodel.ENCRYPTED_PASSWORD = mstuser.ENCRYPTED_PASSWORD
        viewmodel.LAST_PASSWORD_CHANGE = mstuser.LAST_PASSWORD_CHANGE
        viewmodel.INITIAL_PASSWORD = mstuser.INITIAL_PASSWORD
        viewmodel.LOCK = mstuser.LOCK
        viewmodel.FAILED_COUNT = mstuser.FAILED_COUNT
        viewmodel.DISABLED = mstuser.DISABLED
        viewmodel.LAST_LOGIN_DATE = mstuser.LAST_LOGIN_DATE
        viewmodel.LAST_LOGIN_DATE2 = mstuser.LAST_LOGIN_DATE2

        Dim role = From rmap In db.GetTable(Of MAP_ROLE)()
                           Join rmst In db.GetTable(Of MST_ROLE)() On rmap.ROLE_ID Equals rmst.ROLE_ID
                           Where rmap.OPERATOR_ID = viewmodel.OPERATOR_ID

        Dim rolemst = From rmst In db.GetTable(Of MST_ROLE)()

        ' ロールの処理
        For Each item In rolemst
            viewmodel.ROLE.Add(item.ROLE_NAME, False)
        Next

        For Each item In role
            viewmodel.ROLE.Item(item.rmst.ROLE_NAME) = True
        Next


        Return viewmodel
    End Function

    Public Sub LoginSuccessful(ByVal viewmodel As ViewModelLogin)
        Using ts = New TransactionScope
            Using db As New MeetingRoomDBDataContext
                Dim record As MST_USER
                Dim currentDate As String = Now.ToString("yyyy/MM/dd HH:mm:ss")

                record = (From r In db.GetTable(Of MST_USER)() Select r
                            Where r.OPERATOR_ID = viewmodel.OPERATOR_ID).First()

                record.LAST_LOGIN_DATE2 = record.LAST_LOGIN_DATE
                record.LAST_LOGIN_DATE = currentDate
                If record.LAST_LOGIN_DATE2 Is Nothing Then
                    record.LAST_LOGIN_DATE2 = currentDate
                End If
                record.FAILED_COUNT = 0

                db.SubmitChanges()

            End Using

            ts.Complete()
        End Using
    End Sub

    Public Sub LoginFailed(ByVal viewmodel As ViewModelLogin)
        Using ts = New TransactionScope
            Using db As New MeetingRoomDBDataContext
                Dim record As MST_USER
                Dim currentDate As String = Now.ToString("yyyy/MM/dd HH:mm:ss")

                record = (From r In db.GetTable(Of MST_USER)() Select r
                            Where r.OPERATOR_ID = viewmodel.OPERATOR_ID).First()

                record.FAILED_COUNT = record.FAILED_COUNT + 1

                If record.FAILED_COUNT > 6 Then
                    record.LOCK = True
                End If

                db.SubmitChanges()

            End Using

            ts.Complete()
        End Using
    End Sub

    Public Sub SaveChangePassword(ByVal viewmodel As ViewModelChangePassword)
        Dim encryptPassword As String = Crypt.EncryptSHA256(viewmodel.NEW_PASSWORD)

        Using ts = New TransactionScope
            Using db As New MeetingRoomDBDataContext
                Dim record As New MST_USER

                record = (From r In db.GetTable(Of MST_USER)() Select r
                            Where r.OPERATOR_ID = viewmodel.OPERATOR_ID).First

                record.ENCRYPTED_PASSWORD = encryptPassword
                record.LAST_PASSWORD_CHANGE = Now.ToString("yyyy/MM/dd HH:mm:ss")
                record.INITIAL_PASSWORD = False
                record.LOCK = False
                record.FAILED_COUNT = 0

                db.SubmitChanges()

            End Using
            ts.Complete()
        End Using

    End Sub


End Class
