﻿Public Class Util
    ' XMLデータからリストアイテムに値をセットする
    Public Shared Sub AddListItem(ByRef ctrl As List(Of SelectListItem), ByVal KeyNo As Integer)
        Dim xmldoc As XElement = GetDataXML()
        Dim query As IEnumerable(Of XElement) = From x In xmldoc.Descendants("WebFormData") Where x.Attribute("Value1").Value = KeyNo Order By Integer.Parse(x.Attribute("SortNo").Value) Ascending

        For Each i As XElement In query
            Dim Value2 As String = i.Attribute("Value2")
            Dim JPNAME As String = i.Attribute("JPNAME")

            ctrl.Add(New SelectListItem() With {.Text = JPNAME, .Value = Value2})
        Next
    End Sub

    ' XMLデータのコード番号からJPNAMEを取得する
    Public Shared Function GetDataName(ByVal keyNo As String, ByVal Code As String) As String
        Dim JPNAME As String = ""
        Dim xmldoc As XElement = GetDataXML()

        Dim query As IEnumerable(Of XElement) = From x In xmldoc.Descendants("WebFormData") Where x.Attribute("Value1").Value = keyNo AndAlso x.Attribute("Value2").Value = Code

        For Each i As XElement In query
            JPNAME = i.Attribute("JPNAME")
        Next

        Return JPNAME
    End Function

    ' データ用XMLファイルを読み込む
    Public Shared Function GetDataXML() As XElement
        If Not HttpContext.Current.Session.Item("SessionDataXmlPath") Is Nothing Then
            Return HttpContext.Current.Session.Item("SessionDataXmlPath")
        End If

        Dim Path As String = "./../Data/data.xml"
        Dim FullPath As String = HttpContext.Current.Server.MapPath(Path)
        Dim xmldoc As XElement = XElement.Load(FullPath)

        HttpContext.Current.Session.Item("SessionDataXmlPath") = xmldoc
        Return xmldoc
    End Function

    Public Shared Function GetRoleString(ByVal Role() As Boolean, ByVal CheckBoxList As List(Of SelectListItem)) As String
        Dim result As String = ""
        Dim index As Integer = 0
        For Each item In CheckBoxList.AsEnumerable
            If Role(index) = True Then
                result = result & "," & item.Text
            End If
            index = index + 1
        Next

        If result.Length > 0 Then
            result = result.Substring(1)
        End If

        Return result
    End Function

    Public Shared Function Mask(ByVal val As String, Optional ByVal maskedChar As String = "*") As String
        If val Is Nothing Then
            Return ""
        End If

        Dim len As Integer = val.Length
        Dim ret = ""

        For i As Integer = 0 To len - 1
            ret = ret & maskedChar
        Next

        Return ret
    End Function

End Class
